
//
//
// Praktikum 3 in Algorithmen und Datenstrukturen / Fr. Prof. Dr. Kirch-Prinz
// Binrer Baum
//
// made by
//
// Rene Valdez
// Peter Ellenberg
//
//
// Main(), um das Programm zu testen (mittels Menu)
// 

#include "BinBaum.h"

void clear() {
	cout << "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n" << flush;
	cout << "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n" << flush;
}

void main() {

	int atom, test, test2, anzTrees, lauf;
	const int maxtrees = 20;
	int activeIndex = 0;

	Heap<int>* treeVec[maxtrees];

	Heap<int> heap;
	
	heap.insert(4);
	heap.insert(5);
	heap.insert(6);
	heap.insert(1);
	heap.insert(7);
	heap.insert(2);
	heap.insert(19);
	heap.insert(3);
	heap.insert(12);


	treeVec[0]=&heap;
	anzTrees = 1;


	clear();
	while (test != 0) {
		clear();

		cout << "\nProgrammieraufgabe Algorithmen & Datenstrukturen\n" << flush;
		cout << "------------------------------------------------\n" << flush;
		cout << "Binaere Baeume\n\n" << flush;
		cout << "Menu:\n" << flush;
		cout << "--------------------------------------------------------\n" << flush;
		cout << "Aktiver Baum: Baum" << activeIndex+1 << "\n" << flush;
		cout << "(1)	Neuen Knoten anlegen\n" << flush;
		cout << "(2)	kleinsten Knoten loeschen\n" << flush;
		cout << "(3)	im Baum suchen\n" << flush;
		cout << "(4)	Baum ausgeben\n" << flush;
		cout << "(5)	Baum sortiert ausgeben\n" << flush;
		cout << "(6)	Zuweisungsoperator testen\n" << flush;
		cout << "(7)	Kopierkonstruktor testen\n" << flush;
		cout << "(8)	Baum loeschen\n" << flush;
		cout << "(9)	Aktuellen Baum wechseln\n" << flush;
		cout << "(0)	Beenden\n" << flush;
		cout << "--------------------------------------------------------\n\n" << flush;
		cout << "Eingabe: " << flush;
		cin >> test;

		switch(test) {

		case 1: // Einfgen eines Atoms in aktuellen Baum
			cout << "Geben Sie bitte das Atom ein: " << flush << endl;
			cin >> atom;
			try {
				treeVec[activeIndex]->insert(atom);
			} catch (BadAtom& err) {
				cerr << err.getMessage() << flush << endl;
			}
			system("PAUSE");
			break;

		case 2: // Lschen der Wurzel des aktuellen Baums
			try {
				test = treeVec[activeIndex]->deleteMin();
			} catch (NotFound<int>) {
				cout << "Kein Knoten zum loeschen vorhanden !" << flush << endl;
				system("PAUSE");
				break;
			} 
			cout << "Wurzel geloescht !" << flush << endl;
			system("PAUSE");
			break;

		case 3: // Suchen eines Atoms im aktuellen Baum
			cout << "Geben Sie bitte das Atom ein: " << flush;
			cin >> atom;
			try {
				cout << "Atom " << atom << " wurde an Stelle " << treeVec[activeIndex]->find(atom) << " gefunden.\n";
			} catch (NotFound<int>& err) {
				cerr << err.getMessage() << flush << endl;
			}
			system("PAUSE");
			break;

		case 4: // Anzeigen des aktuellen Baums
			clear();
			treeVec[activeIndex]->showTree(*treeVec[activeIndex]);
			system("PAUSE");
			break;

		case 5: // Sortierten Anzeigen des aktuellen Baums
			clear();
			treeVec[activeIndex]->sort();
			system("PAUSE");
			break;

		case 6: // Erstellen eines neuen Baums mittels des Zuweisungsoperators

			clear();
			
			if (anzTrees<maxtrees) {
				cout << "Ein neuer Baum wird mittels des Zuweisungsoperators erstellt.\n";
				cout << "Welchen Baum wollen sie Baum" << (anzTrees+1) << " zuweisen?\n\n";
				for (lauf = 1; lauf <= anzTrees; lauf++) {
					cout << " (" << lauf << ") Baum " << lauf << endl;
				};
				
				cout << " (0) Zurueck zum Hauptmenue\n";
				cout << "\nEingabe: " << flush;
				cin >> test2;
				
				if ((test2>0) && (test2<=anzTrees)) {
					anzTrees++;
					activeIndex = anzTrees - 1;
					treeVec[activeIndex] = new Heap<int>;

					// Hier wird Zuweisungsoperator getestet
					*treeVec[activeIndex] = *treeVec[test2-1];
				}
			} else { cout << "Die maximale Anzahl an Baeumen ist erreicht."; 
					 system("PAUSE");}

			
			break;

		case 7: // Erstellen eines neuen Baums mittels des Kopierkonstruktors

			clear();
			
			if (anzTrees<maxtrees) {
				cout << "Ein neuer Baum wird mittels des Kopierkonstruktors erstellt.\n";
				cout << "Welchen Baum wollen sie in Baum" << (anzTrees+1) << " kopieren?\n\n";
				for (lauf = 1; lauf <= anzTrees; lauf++) {
					cout << " (" << lauf << ") Baum " << lauf << endl;
				};
				
				cout << " (0) Zurueck zum Hauptmenue\n";
				cout << "\nEingabe: " << flush;
				cin >> test2;
				
				if ((test2>0) && (test2<=anzTrees)) {
					anzTrees++;
					activeIndex = anzTrees - 1;

					// Hier wird der Kopierkonstruktor getestet
					treeVec[activeIndex] = new Heap<int>(*treeVec[test2-1]);
				}
			} else { cout << "Die maximale Anzahl an Baeumen ist erreicht."; 
					 system("PAUSE");}

			
			break;

		case 8:  //Lschen eines Baums

			clear();
			
			if (anzTrees>1) {
				cout << "Welchen Baum moechten sie loeschen?\n\n";
				for (lauf = 1; lauf <= anzTrees; lauf++) {
					cout << " (" << lauf << ") Baum " << lauf << endl;
				};
				
				cout << " (0) Zurueck zum Hauptmenue\n";
				cout << "\nEingabe: " << flush;
				cin >> test2;
			
				if ((test2>0) && (test2<=anzTrees)) {
					if (activeIndex=test2-1) {activeIndex=0;}
					for (lauf=test2; lauf < anzTrees; lauf++) {
						treeVec[lauf-1]=treeVec[lauf];
					}
					anzTrees--;
				}
			}
			else
			{ cout << "Der letzte Baum kann nicht geloescht werden!\n";
			  system("PAUSE");
			}

			
			break;

		case 9: // Wechseln des aktiven Baums
					
			clear();
				
			cout << "Zu welchen Baum wollen sie wechseln?\n\n";
			for (lauf = 1; lauf <= anzTrees; lauf++) {
				cout << " (" << lauf << ") Baum " << lauf << "  " << treeVec[lauf-1] << endl;
			};
			
			cout << " (0) Zurueck zum Hauptmenue\n";
			cout << "\nEingabe: " << flush;
			cin >> test2;
			
			if ((test2>0) && (test2<=anzTrees)) {
				activeIndex = test2-1;
			}

			break;
		case 0:
			break;;
		default:
			break;
		}
	}
}
